AssertWireColor("Green", "0.0 0.8 0.0");
AssertWireColor("Gray", "0.3 0.3 0.3");
AssertWireColor("Red", "0.8 0.0 0.0");
AssertWireColor("Blue", "0.0 0.0 0.8");
AssertWireColor("TransYellow", "0.8 0.8 0.0 0.5");
AssertWireColor("TransWhite", "1.0 1.0 1.0 0.5");

function TransWirePlant(%temp, %brick) { %brick.setRaycasting(0); }

DefineWireCategory("Misc", "Wires I haven't found a home for yet.");

DefineWire("V", 2, "", "", "TransWirePlant", "1\t150\tonRelay\tSelf\tFireRelaySouth\n1\t0\tonRelay\tSelf\tSetColor\tTransYellow\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tTransWhite", "Ghost Wire", "Acts like the Basic Wire, but does not block projectiles.", "Misc", "TransWhite");

DefineWire("U", 2, "", "", "", "1\t1500\tonRelay\tSelf\tFireRelaySouth\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t1500\tonRelay\tSelf\tSetColor\tBlack", "Slow Wire", "Transmits a pulse at roughly 2/3rds a stud per second.", "Misc");

DefineWire("V", 2, "", "", "", "1\t150\tonRelay\tSelf\tSpawnProjectile\t0 -20 0\tRadioWaveProjectile\t0 0 0\t1\n"@
	"1\t0\tonRelay\tSelf\tSetColor\tPulse\n1\t150\tonRelay\tSelf\tSetColor\tGray", "Projectile Firer", "Fires a radio wave when a pulse is received.", "Misc", "Gray");

DefineWire("V", 2, "", "", "", "1\t0\tonProjectileHit\tSelf\tSetColor\tRed\n0\t0\tonProjectileHit\tSelf\tSetColor\tGreen\n"@
	"1\t0\tonProjectileHit\tSelf\tToggleEventEnabled\t0 1 3 4 5 6\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tFireRelaySouth\n0\t150\tonRelay\tSelf\tSetColor\tRed\n1\t150\tonRelay\tSelf\tSetColor\tGreen",
	"Toggle Switch", "Toggles states when hit by a projectile.", "Misc", "Green");

DefineWire("V", 2, "", "", "", "1\t150\tonProjectileHit\tSelf\tFireRelaySouth\n1\t0\tonProjectileHit\tSelf\tSetColor\tRed\n"@
	"1\t150\tonProjectileHit\tSelf\tSetColor\tBlue\n1\t150\tonRelay\tSelf\tFireRelaySouth\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlue", "Projectile Detector", "Fires a pulse when hit by a projectile.", "Misc", "Blue");

DefineWire("X", 0, "", "", "TransWirePlant", "1\t0\tonRelay\tSelf\tSetColor\tYellow\n1\t0\tonRelay\tSelf\tSetRaycasting\t1\n"@
	"0\t150\tonRelay\tSelf\tSetRaycasting\t0\n1\t150\tonRelay\tSelf\tSetColor\tRed\n"@
	"0\t150\tonRelay\tSelf\tSetColor\tGreen\n1\t200\tonRelay\tSelf\tToggleEventEnabled\t1 2 3 4",
	"Projectile Blocker", "Toggles blocking projectiles whenever a pulse is received.", "Misc", "Green");

DefineWire("J", 2, "", "", "", "1\t0\tonRelay\tSelf\tSetColor\tPulse\n1\t450\tonRelay\tSelf\tFireRelaySouth\n"@
	"1\t450\tonRelay\tSelf\tSetColor\tBlack\n1\t450\tonRelay\tSelf\tSetEventEnabled\t7 8 9 10 11 12\t0\n"@
	"1\t450\tonRelay\tSelf\tSetEventEnabled\t0 1 2 3 4 5 6\t1\n1\t0\tonRelay\tSelf\tSetEventEnabled\t0 1 2 3 4 5 6\t0\n"@
	"1\t0\tonRelay\tSelf\tSetEventEnabled\t7 8 9 10 11 12\t1\n0\t0\tonRelay\tSelf\tCancelEvents\n"@
	"0\t0\tonRelay\tSelf\tSetColor\tCharged\n0\t450\tonRelay\tSelf\tFireRelayWest\n0\t450\tonRelay\tSelf\tSetColor\tBlack\n"@
	"0\t450\tonRelay\tSelf\tSetEventEnabled\t0 1 2 3 4 5 6\t1\n0\t450\tonRelay\tSelf\tSetEventEnabled\t7 8 9 10 11 12\t0",
	"Blocking Switch", "Fires a pulse to the right if more than one pulse is received.", "Misc", "Black");