AssertWireColor("TransRed", "0.8 0.0 0.0 0.5");
AssertWireColor("TransOrange", "0.8 0.4 0.0 0.5");
AssertWireColor("TransYellow", "0.8 0.8 0.0 0.5");
AssertWireColor("TransGreen", "0.0 0.8 0.0 0.5");
AssertWireColor("TransBlue", "0.0 0.0 0.8 0.5");
AssertWireColor("TransPurple", "0.4 0.0 0.8 0.5");
AssertWireColor("TransWhite", "1.0 1.0 1.0 0.5");

function LightWireCleanup(%temp)
{
	if(isObject(%top = %temp.lightTop))
		%top.cleanupDelete = %top.schedule(0, "delete");
}

function LightWireUpdate(%temp)
{
	if(!isObject(%top = %temp.lightTop))
	{
		%top = (%temp.lightTop = new fxDtsBrick()
		{
			colorID = GetWireColor("Trans"@getWord($WireName[%temp.wireCat, %temp.wireID],0));
			datablock = brick1x1RoundData;
		});
		%top.wireBrick = 1;
	}
	if(isEventPending(%top.cleanupDelete))
	{
		cancel(%top.cleanupDelete); %top.wireBrick = 0;
		%top.setColor(GetWireColor("Trans"@getWord($WireName[%temp.wireCat, %temp.wireID],0))); %top.wireBrick = 1;
	}
	%top.setTransform(vectorAdd(%temp.getPosition(), "0 0 0.4") SPC getWords(%temp.getTransform(), 3, 6));
}

function LightWirePlant(%temp, %brick)
{
	if(!isObject(%top = %temp.lightTop))
	{ %brick.schedule(50, "delete"); return; }
	else
	{
		%brick.client.player.tempbrick = %top;
		%topBrick = servercmdPlantBrick(%brick.client);
		%brick.client.player.tempbrick = %temp;
		if(isObject(%topBrick))
		{
			%color = getWord($WireName[%temp.wireCat, %temp.wireID],0);
			if(%color $= "White") %color = "Player";
			%data = (%color@"Light").getID(); %topBrick.clearEvents();
			%topBrick.addEvent(1, 0, "onRelay", "Self", "SetLight", %data);
			%topBrick.addEvent(0, 0, "onRelay", "Self", "SetLight", -1);
			%topBrick.addEvent(1, 0, "onRelay", "Self", "PlaySound", LightOnSound);
			%topBrick.addEvent(0, 0, "onRelay", "Self", "PlaySound", LightOffSound);
			%topBrick.addEvent(1, 0, "onRelay", "Self", "ToggleEventEnabled", "0 1 2 3");
		}
		else %brick.schedule(50, "delete");
	}
}

DefineWireCategory("Lightbulbs", "Emit light if given a charge.");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Red Light", "Toggles emitting red light when a pulse is received.", "Lightbulbs");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Orange Light", "Toggles emitting orange light when a pulse is received.", "Lightbulbs");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Yellow Light", "Toggles emitting yellow light when a pulse is received.", "Lightbulbs");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Green Light", "Toggles emitting green light when a pulse is received.", "Lightbulbs");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Blue Light", "Toggles emitting blue light when a pulse is received.", "Lightbulbs");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Purple Light", "Toggles emitting purple light when a pulse is received.", "Lightbulbs");

DefineWire(" ", 0, "LightWireCleanup", "LightWireUpdate", "LightWirePlant",
	"1\t150\tonRelay\tSelf\tFireRelayUp\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "White Light", "Toggles emitting white light when a pulse is received.", "Lightbulbs");