DefineWireCategory("Triggers", "Fires a pulse when clicked.");

function ClickTriggerCleanup(%temp)
{
	if(isObject(%top = %temp.buttonTop))
		%top.delete();
}

function ClickTriggerPlant(%temp, %brick)
{
	if(!isObject(%top = %temp.buttonTop))
	{ %brick.schedule(50, "delete"); return; }
	else
	{
		%brick.client.player.tempbrick = %top;
		%topBrick = servercmdPlantBrick(%brick.client);
		%brick.client.player.tempbrick = %temp;
		if(isObject(%topBrick))
		{
			%topBrick.addEvent(1, 150, "onActivate", "Self", "FireRelayDown");
			%topBrick.addEvent(1, 0, "onActivate", "Self", "SetColor", GetWireColor("Pulse"));
			%topBrick.addEvent(1, 150, "onActivate", "Self", "SetColor", GetWireColor("Black"));
			%topBrick.addEvent(1, 0, "onActivate", "Self", "PlaySound", Beep_Key_Sound);
		}
		else %brick.schedule(50, "delete");
	}
}

function VClickTriggerUpdate(%temp)
{
	if(!isObject(%top = %temp.buttonTop))
	{
		%top = (%temp.buttonTop = new fxDtsBrick()
		{
			colorID = GetWireColor("Black");
			datablock = brick1x1FPrintData;
		});
		%top.wireBrick = 1; %top.SetChar("V");
	}
	%top.setTransform(vectorAdd(%temp.getPosition(), "0 0 0.2") SPC getWords(%temp.getTransform(), 3, 6));
}

DefineWire(" ", 2, "ClickTriggerCleanup", "VClickTriggerUpdate", "ClickTriggerPlant",
	"1\t150\tonRelay\tSelf\tFireRelaySouth\n1\t0\tonRelay\tSelf\tSetColor\tPulse\n"@
	"1\t150\tonRelay\tSelf\tSetColor\tBlack", "Basic Trigger", "Transmits a pulse when clicked.", "Triggers");

function OClickTriggerUpdate(%temp)
{
	if(!isObject(%top = %temp.buttonTop))
	{
		%top = (%temp.buttonTop = new fxDtsBrick()
		{
			colorID = GetWireColor("Black");
			datablock = brick1x1FPrintData;
		});
		%top.wireBrick = 1; %top.SetChar("O");
	}
	%top.setTransform(vectorAdd(%temp.getPosition(), "0 0 0.2") SPC getWords(%temp.getTransform(), 3, 6));
}

DefineWire(" ", 0, "ClickTriggerCleanup", "OClickTriggerUpdate", "ClickTriggerPlant",
	"1\t150\tonRelay\tSelf\tFireRelayNorth\n1\t150\tonRelay\tSelf\tFireRelayEast\n"@
	"1\t150\tonRelay\tSelf\tFireRelaySouth\n1\t150\tonRelay\tSelf\tFireRelayWest\n"@
	"1\t0\tonRelay\tSelf\tSetColor\tPulse\n1\t150\tonRelay\tSelf\tSetColor\tBlack",
	"Omnidirectional Trigger", "Transmits a pulse in all directions when clicked.", "Triggers");

DefineWire("!", 0, "", "", "", "0\t0\tonActivate\tSelf\tSetColor\tPulse\n0\t150\tonActivate\tSelf\tSetColor\tBlack\n"@
	"0\t150\tonActivate\tSelf\tFireRelayNorth\n0\t0\tonActivate\tSelf\tSetEventEnabled\t0 1 2 3\t0\n"@
	"1\t0\tonRelay\tSelf\tSetColor\tPulse\n1\t150\tonRelay\tSelf\tSetColor\tCharged\n"@
	"1\t150\tonRelay\tSelf\tSetEventEnabled\t0 1 2 3\t1", "Chargable Switch", "Releases a stored charge when clicked.", "Triggers");